### Hierarchy

- Layout
  - ForceDirectedLayout

Force-directed layout treats the graph as if it were a system of physical bodies with repulsive electrical, attractional gravitational, and spring forces acting on them and between them.

Electrical forces come both from the field at the vertex's location as well as from neighboring vertexes and are quadratic by distance. Gravitational forces come from the field at the vertex's location and are constant. Spring forces are only exerted between two different vertexes that are connected by an edge and are linear by distance.

The electrical forces on a vertex are the sum of the electrical charge times the electrical field at that location (electricalCharge, electricalFieldX, electricalFieldY) and the electrical forces of all nearby vertexes divided by the square of the distance between them. You can easily assign the electrical charge for all vertexes by assigning defaultElectricalCharge. By default there is no electrical field, so all forces are due to nearby charged vertexes. For efficiency, infinityDistance determines a cut-off distance between vertexes for which to consider any influence.

The gravitational forces on a vertex are the sum of the gravitational mass times the gravitational field at that location (gravitationalMass, gravitationalFieldX, gravitationalFieldY). You can easily assign the gravitational mass for all vertexes by assigning defaultGravitationalMass. By default there is no gravitational field.

The spring forces on a vertex are only exerted by the edges connecting it with other vertexes. The force along an edge is the stiffness of the spring times the difference of the distance between the vertexes and the nominal length of the spring (springStiffness, springLength) divided by the distance between the vertexes. When the distance is less than the nominal length, the force pushes the vertexes apart; when the distance is greater, the force pulls them together. You can easily assign the spring length and stiffness for all edges by assigning defaultSpringLength and defaultSpringStiffness.

When the distance between two vertexes is less than one unit, this uses a random number generator to decide which direction the forces should go. For layouts that start with all of the vertexes at the same location, this results in potentially dramatically different results. Set randomNumberGenerator to null in order to produce reproducible results given the same initial vertex locations.

The algorithm seeks a configuration of the bodies with locally minimal energy, i.e. vertex positions such that the sum of the forces on each vertex is zero. This is achieved by repeatedly computing the forces on each vertex, moving them, and repeating. Computations stop when no vertex moves more than epsilonDistance or when maxIterations have happened.

The layout cannot guarantee that it provides optimal positioning of nodes. Nodes will normally not overlap each other, but when there is a dense interconnectivity overlaps might not be avoidable.

If you want to experiment interactively with most of the properties, try the Force Directed Layout sample. See samples that make use of ForceDirectedLayout in the samples index.

This layout makes use of a LayoutNetwork of ForceDirectedVertexes and ForceDirectedEdges that normally correspond to the Nodes and Links of the Diagram.

## Index

### Constructors

- constructor

### Properties

- arrangementSpacing
- arrangesToOrigin
- comments
- currentIteration
- defaultCommentElectricalCharge
- defaultCommentSpringLength
- defaultElectricalCharge
- defaultGravitationalMass
- defaultSpringLength
- defaultSpringStiffness
- epsilonDistance
- infinityDistance
- maxIterations
- moveLimit
- randomNumberGenerator
- setsPortSpots

### Methods

- addComments
- commitLayout
- commitLinks
- commitNodes
- createNetwork
- doLayout
- electricalCharge
- electricalFieldX
- electricalFieldY
- gravitationalFieldX
- gravitationalFieldY
- gravitationalMass
- isFixed
- moveFixedVertex
- springLength
- springStiffness

## Constructors

### constructor

- new ForceDirectedLayout(): ForceDirectedLayout

- Constructs a ForceDirectedLayout with no Layout.network and with no owning Layout.diagram.

  #### Returns ForceDirectedLayout

## Properties

### arrangementSpacing : Size

- Gets or sets the space between which the layout will position the connected graphs that together compose the network. This defaults to Size(100, 100). These distances are used during a clustered layout; afterwards the normal force-directed layout will likely cause the size of any space between connected graphs to change, perhaps considerably.

### arrangesToOrigin : boolean

- Gets or sets whether commitNodes should move all of the nodes so that the nodes all fit with the top-left corner at the Layout.arrangementOrigin. By default this is false -- the Layout.arrangementOrigin is ignored. When this is true, nodes are moved even though isFixed was true.

### comments : boolean

- Gets or sets whether this layout should find all Nodes whose category is "Comment" and whose anchors are nodes represented in the network, and add ForceDirectedVertexes representing those balloon comments as nodes in the network. The default value is false.

### Read-only currentIteration : number

- This read-only property returns the current iteration count, valid during a call to doLayout.

### defaultCommentElectricalCharge : number

- Gets or sets the default value computed by electricalCharge. The initial value is 5.

### defaultCommentSpringLength : number

- Gets or sets the default value computed by springLength. The initial value is 10.

### defaultElectricalCharge : number

- Gets or sets the default value computed by electricalCharge. The initial value is 150.

### defaultGravitationalMass : number

- Gets or sets the default value computed by gravitationalMass. The initial value is zero.

### defaultSpringLength : number

- Gets or sets the default value computed by springLength. The initial value is 50.

### defaultSpringStiffness : number

- Gets or sets the default value computed by springStiffness. The initial value is 0.05.

### epsilonDistance : number

- Gets or sets approximately how far a node must move in order for the iterations to continue. The default value is 1. The value must be larger than zero.

### infinityDistance : number

- Gets or sets a threshold for the distance beyond which the electrical charge forces may be ignored. The default value is 1000. The value must be larger than 1.

### maxIterations : number

- Gets or sets the maximum number of iterations to perform when doing the force-directed auto layout. The value must be non-negative. The default value is 100.

### moveLimit : number

- Gets or sets how far a vertex may be moved in an iteration. The default value is 10. The value must be larger than 1.

  since

    1.8

### randomNumberGenerator : object

- Gets or sets a random number generator. The default value is Math, which results in calling Math.random(). Change this to null in order to use an instance of an internal repeatable pseudo-random number generator, which will become the new value of this property.

  The new value must be either null or an Object with a method named "random" taking zero arguments and returning a random number between zero (inclusive) and one (exclusive).

  since

    1.5

### setsPortSpots : boolean

- Gets or sets whether the fromSpot and the toSpot of every Link should be set to Spot.Default. The default value is true.

## Methods

### Virtual addComments

- addComments(v: ForceDirectedVertex): void

- Find any associated objects to be positioned along with the LayoutVertex.node.

  This method is called for each vertex in the network, when comments is true. The standard behavior is to look for Nodes whose Part.category is "Comment" and that refer to the LayoutVertex.node. By default this method will not be called unless you set comments to true.

  You may want to override this method in order to customize how any associated objects are found and how a new ForceDirectedVertex and ForceDirectedEdge may be added to the network to represent the (balloon?) comment. This method sets the new vertex's ForceDirectedVertex.charge to the value of defaultCommentElectricalCharge, and sets the new edge's ForceDirectedEdge.length to the value of defaultCommentSpringLength.

  since

    1.3

  #### Parameters

  - ##### v: ForceDirectedVertex

  #### Returns void

### Protected Override commitLayout

- commitLayout(): void

- Set the fromSpot and toSpot on each Link, position each Node according to the vertex position, and then position/route the Links.

  This calls the commitNodes and commitLinks methods, the latter only if isRouting is true. You should not call this method -- it is a "protected virtual" method. Please read the Introduction page on Extensions for how to override methods and how to call this base method.

  #### Returns void

### Protected Virtual commitLinks

- commitLinks(): void

- Routes the links.

  This is called by commitLayout. This is only called if Layout.isRouting is true. See also commitNodes. Please read the Introduction page on Extensions for how to override methods and how to call this base method.

  #### Returns void

### Protected Virtual commitNodes

- commitNodes(): void

- Commit the position of all nodes.

  This is called by commitLayout. See also commitLinks. Please read the Introduction page on Extensions for how to override methods and how to call this base method.

  #### Returns void

### Override createNetwork

- createNetwork(): ForceDirectedNetwork

- Create a new LayoutNetwork of ForceDirectedVertexes and ForceDirectedEdges.

  #### Returns ForceDirectedNetwork

  a new LayoutNetwork.

### Override doLayout

- doLayout(coll: Diagram | Group | Iterable<Part>): void

- Perform the force-directed layout.

  If there is no Layout.network, this calls makeNetwork to create a LayoutNetwork from the given collection of Parts. This removes any reflexive edges in the network, since they should be ignored.

  For each vertex this calls and remembers the result of electricalCharge as the ForceDirectedVertex.charge and the result of gravitationalMass as the ForceDirectedVertex.mass.

  For each edge this calls and remembers the result of springStiffness as the ForceDirectedEdge.stiffness and the result of springLength as the ForceDirectedEdge.length.

  This then iterates, updating the position of each vertex according to the forces upon it, until reaching maxIterations or until no vertex moves more than about epsilonDistance.

  Finally this calls Layout.updateParts to commit the Node positions from the vertex positions. Layout.updateParts calls commitLayout within a transaction.

  #### Parameters

  - ##### coll: Diagram | Group | Iterable<Part>

    A Diagram or a Group or a collection of Parts

  #### Returns void

### Virtual electricalCharge

- electricalCharge(v: ForceDirectedVertex): number

- Returns the charge of the vertex, the value of ForceDirectedVertex.charge if it's a number, or else the value of defaultElectricalCharge.

  The electrical forces between two vertexes decrease by the square of the distance between them. Vertexes that are more than infinityDistance apart are assumed to have no electrical charge effect on each other.

  Please read the Introduction page on Extensions for how to override methods and how to call this base method.

  #### Parameters

  - ##### v: ForceDirectedVertex

  #### Returns number

### Virtual electricalFieldX

- electricalFieldX(x: number, y: number): number

- Returns the electrical field in the X direction acting on a vertex at the given point. By default there is no electrical field at any location.

  Used to define an external electrical field at a point independent of the vertex charges. A vertex L is acted upon by a force in the X direction of proportional to `electricalFieldX(L.center.x, L.center.y) * electricalCharge(L)`. Please read the Introduction page on Extensions for how to override methods and how to call this base method.

  #### Parameters

  - ##### x: number

  - ##### y: number

  #### Returns number

  the default implementation returns zero.

### Virtual electricalFieldY

- electricalFieldY(x: number, y: number): number

- Returns the electrical field in the Y direction acting on a vertex at the given point. By default there is no electrical field at any location.

  Used to define an external electrical field at a point independent of the vertex charges. A vertex L is acted upon by a force in the Y direction of proportional to `electricalFieldY(L.center.x, L.center.y) * electricalCharge(L)`. Please read the Introduction page on Extensions for how to override methods and how to call this base method.

  #### Parameters

  - ##### x: number

  - ##### y: number

  #### Returns number

  the default implementation returns zero.

### Virtual gravitationalFieldX

- gravitationalFieldX(x: number, y: number): number

- This returns the gravitational field in the X direction acting on a vertex at the given point. By default there is no gravitational field at any location.

  Used to define an external gravitational field at a point independent of the vertex masses. A vertex L is acted upon by a force in the X direction of proportional to `gravitationalFieldX(L.center.x, L.center.y) * gravitationalMass(L)`. Please read the Introduction page on Extensions for how to override methods and how to call this base method.

  #### Parameters

  - ##### x: number

  - ##### y: number

  #### Returns number

  the default implementation returns zero.

### Virtual gravitationalFieldY

- gravitationalFieldY(x: number, y: number): number

- This returns the gravitational field in the Y direction acting on a vertex at the given point. By default there is no gravitational field at any location.

  Used to define an external gravitational field at a point independent of the vertex masses. A vertex L is acted upon by a force in the Y direction of proportional to `gravitationalFieldY(L.center.x, L.center.y) * gravitationalMass(L)`. Please read the Introduction page on Extensions for how to override methods and how to call this base method.

  #### Parameters

  - ##### x: number

  - ##### y: number

  #### Returns number

  the default implementation returns zero.

### Virtual gravitationalMass

- gravitationalMass(v: ForceDirectedVertex): number

- Returns the mass of the vertex, the value of ForceDirectedVertex.mass if it's a number, or else the value of defaultGravitationalMass. Please read the Introduction page on Extensions for how to override methods and how to call this base method.

  #### Parameters

  - ##### v: ForceDirectedVertex

  #### Returns number

### Virtual isFixed

- isFixed(v: ForceDirectedVertex): boolean

- This predicate returns true if the vertex should not be moved by the layout algorithm but still have an effect on nearby and connected vertexes. The default implementation returns ForceDirectedVertex.isFixed. Please read the Introduction page on Extensions for how to override methods and how to call this base method.

  #### Parameters

  - ##### v: ForceDirectedVertex

  #### Returns boolean

  returns true if the node should not be moved by the layout algorithm.

### Virtual moveFixedVertex

- moveFixedVertex(v: ForceDirectedVertex): void

- Maybe move a vertex that isFixed. This is called each iteration on each such vertex. By default this does nothing.

  #### Parameters

  - ##### v: ForceDirectedVertex

  #### Returns void

### Virtual springLength

- springLength(e: ForceDirectedEdge): number

- Returns the length of the spring representing an edge. The two vertexes connected by the edge E are acted upon by a force of proportional to `springStiffness(E) * (getNodeDistance(E.fromVertex, E.toVertex) - springLength(E))` divided by the distance between the vertexes. Please read the Introduction page on Extensions for how to override methods and how to call this base method.

  #### Parameters

  - ##### e: ForceDirectedEdge

  #### Returns number

  Returns the length of the edge representing a link, the value of ForceDirectedEdge.length if it's a number, or else the value of defaultSpringLength.

### Virtual springStiffness

- springStiffness(e: ForceDirectedEdge): number

- Returns the stiffness of the spring representing an edge.

  The spring force between two vertexes connected by an edge is linearly proportional by distance to the difference between the springLength and the distance. When the distance is greater than the length, the force pulls the vertexes closer to each other. When the distance is less than the length, the force pushes them apart.

  The two vertexes connected by the edge E are acted upon by a force of proportional to `springStiffness(E) * (getNodeDistance(E.fromVertex, E.toVertex) - springLength(E))` divided by the distance between the vertexes. Please read the Introduction page on Extensions for how to override methods and how to call this base method.

  #### Parameters

  - ##### e: ForceDirectedEdge

  #### Returns number

  Returns the stiffness of the edge representing a link, the value of ForceDirectedEdge.stiffness if it's a number, or else the value of defaultSpringStiffness.

Copyright © 1998-2021 by Northwoods Software Corporation.